#pragma once

#define DEF_TITLE_REL_LEFT_POS_X			(11)
#define DEF_TITLE_REL_RIGHT_POS_X			(10)
#define DEF_EDIT_REL_TOP_POS_Y				(2)
#define DEF_EDIT_COLOR_BG					RGB(242,243,246)

#define ID_EDIT_SEARCH_ITEM					(0x6001)

// CInfoSearchWnd
class CInfoSearchWnd : public CWnd
{
	DECLARE_DYNAMIC(CInfoSearchWnd)

public:
	CInfoSearchWnd();
	virtual ~CInfoSearchWnd();

	void				SetImgBGPath(CString strFileName);
	void				SetImgSearchPath(CString strFileName, CString strFileNameOvr, CString strFileNameClick);

	int					GetImgBGWidth();
	int					GetImgBGHeight();
	void				SetEditFont(CFont* pFont);
	void				SetEditPosTopY(int nPosTopY);
	void				SetEditBkColor(COLORREF crBk);

	void				SetIntroducingText(CString strIntroduce = _T(""));		// ⺻ ̳, ڰ Էϸ   ִ. (default  ٽ ʱȭ ־ )
	CString				GetIntroducingText()						{ return m_strIntroducing; }

	void				SetDefaultText(CString strDefault)		{ m_strDefault = strDefault; }	// ⺻ ǥõ 
	CString				GetDefaultText()						{ return m_strDefault; }

	void				SetEditSearch(BOOL bEdit);
	void				SetSearchText(CString strSearch)			{ m_strSearchText = strSearch; }
	CString				GetSearchText()								{ return m_strSearchText; }
	void				SetResetSearchText(BOOL bCleanAfterSearch = TRUE);	// ˻   ˻ ʱȭ  
	void				SetSearchChatRoom(BOOL bValue) { m_bSearchChatRoom = bValue; }

	void				ShowIntroducingText();
    void                SetToolTipText(const CString& strText);
protected:
	DECLARE_MESSAGE_MAP()

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnDestroy();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	void OnEditUpdate();

private:
	// BG
	Image*				m_pImgBG;
	Image*				m_pImgSearch;
	Image*				m_pImgSearchOver;
	Image*				m_pImgSearchClick;


	// dimension
	CRect				m_rtWnd;
	CRect				m_rtSearch;
	CRect				m_rtEdit;
	CRect				m_rtSearchText;


	// attribute
	CString				m_strSearchText;
	BOOL				m_bResetSearchText;


	// tracking
	BOOL				m_bTracking;
	BOOL				m_bHoverSearch;
	BOOL				m_bDownSearch;

	CBrush*				m_pEditBkBrush;

	// edit
	CEdit				m_edit;
	CString				m_strIntroducing;
	CString				m_strDefault;
	BOOL				m_bEditSearch;
	int					m_nEditPosTopY;
	COLORREF			m_crEditBk;

	BOOL				m_bSearchChatRoom;
    CToolTipCtrl m_ToolTip;

};
